"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.iterateAsync = void 0;
const utils_1 = require("@graphql-tools/utils");
function iterateAsync(iterable, callback, results) {
    const iterator = iterable[Symbol.iterator]();
    function iterate() {
        const { done: endOfIterator, value } = iterator.next();
        if (endOfIterator) {
            return;
        }
        const result$ = callback(value);
        if ((0, utils_1.isPromise)(result$)) {
            return result$.then(result => {
                if (result) {
                    results?.push(result);
                }
                return iterate();
            });
        }
        if (result$) {
            results?.push(result$);
        }
        return iterate();
    }
    return iterate();
}
exports.iterateAsync = iterateAsync;
